#goes into main section of main.py: execfile('thisfile')
execfile(os.path.join(mainsdir,"nfcalc.py"))


#test params so you can run this w/o main.py
#epss='6.7 + 7.37252694248952e+28/(2.23135858631412e+28 - 896640702624.001*I*omega - omega**2)'
#eps=[1,sympy.sympify(epss),sympy.sympify(epss)]
# sorp='TE'
# nb=no=1000
# nforff='NF'
# T1=300;T2=299
#d=1e-6


def getepsilons(afile):
	import csv
	import StringIO
	epsd={}
	for aline in csv.reader(StringIO.StringIO(epstxt)):
		if len(aline)!=2:continue
		if '#' in aline[:10]:continue
		epsname,epsfun=aline;epsname=epsname.strip()
		epsd.update({epsname:epsfun})
	return epsd
	
#eps=[1,sympy.sympify(eps1),sympy.sympify(eps2)]
epsilons=getepsilons(epstxt)
eps=[1,sympy.sympify(epsilons[eps1.strip()]),sympy.sympify(epsilons[eps2.strip()])]


def ismanualintlims():
#using zero to signify none..b/c rappture forces me to input a default value
	#user changed beta and omega input
	if (inbeta1!=0 or inbeta2!=0) and (inomega1!=0 or inomega2!=0):
		#now chk if 1 b/w betas
		if (inbeta1<1 and inbeta2>1) or (inbeta1>1 and inbeta2<1):
			raise ValueError('1.0 must not be in the interval between beta1 and beta2')
		#now the NF/FF must be in accord with beta selection
		if nforff=='FF' and (inbeta1>1 or inbeta2>1):
			raise ValueError('This beta range does not apply to the far-field.')
		if nforff=='NF' and (inbeta1<1 or inbeta2<1):
			raise ValueError('This beta range does not apply to the near-field')
		return True
	#but if user only changed one of them..raise error
	if (inbeta1!=0 or inbeta2!=0) or (inomega1!=0 or inomega2!=0):
        	raise ValueError('Input all limits for manual integration')
	return False

ismanualintlims=ismanualintlims()

def fqwargs():
#subs consts
	if sorp == 'TE' and nforff=='NF':s=((  sevan('s').subs(consts).subs({'d':(din)})   ))
	if sorp == 'TM' and nforff=='NF':s=((  sevan('p').subs(consts).subs({'d':(din)})   ))
	if sorp == 'TE' and nforff=='FF':s=((  sprop('s').subs(consts).subs({'d':(din)})   ))
	if sorp == 'TM' and nforff=='FF':s=((  sprop('p').subs(consts).subs({'d':(din)})   ))
	if nforff == 'NF' and ismanualintlims==False: beta1=1.00001;beta2=beta1+bchunk;
	if nforff == 'NF' and ismanualintlims==True:
		beta1=inbeta1;beta2=inbeta2;
		if beta1==1:beta1=1.00001
		if beta2==1:beta2=1.00001
	if nforff == 'FF' and ismanualintlims==False: beta1=0;beta2=.99999
	if nforff == 'FF' and ismanualintlims==True:
		beta1=inbeta1;beta2=inbeta2;
		if beta1==1:beta1=.99999
		if beta2==1:beta2=.99999
	s=sym2num(str(  s  ))
	return (s,beta1,beta2,T1,T2)
	


qwargs=fqwargs()
qwkwargs={'no':no*omegalim(max(qwargs[3],qwargs[4]))/1e14,'nb':nb*(qwargs[2]-qwargs[1])}

if ismanualintlims==True:
	qwkwargs.update({'omega1':inomega1});qwkwargs.update({'omega2':inomega2})
	#if it's manual then nchunk shouldn't be a variable.
	#so i'm going to force it to the default variable if the user changed it
	io.put('input.phase(paramin).group(calc).group(calcopts).integer(chunk).current',
	io.get('input.phase(paramin).group(calc).group(calcopts).integer(chunk).default'))
	qw=evalqw(*qwargs,**qwkwargs)
else:#auto
	qw=evalqwauto(*qwargs,**qwkwargs)
	io.put('input.phase(paramin).group(calc).group(calcopts).group(intlims).number(beta1).current',(qwargs[1]))
	io.put('input.phase(paramin).group(calc).group(calcopts).group(intlims).number(beta2).current',numpy.real( programdata['bs'][-1] ))
	io.put('input.phase(paramin).group(calc).group(calcopts).group(intlims).number(omega1).current',0)
	io.put('input.phase(paramin).group(calc).group(calcopts).group(intlims).number(omega2).current',numpy.real( programdata['os'][-1] ))

#the below is unnecessary but i'm too lazy to change it now. it's better to loop and append
#into io.put('output.curve(qw).component.xy', line, append=1)
def takeoutseparators(line):
	line=line.replace('[','');line=line.replace(']','')
	line=line.replace('(','');line=line.replace(')','')
	line=line.replace(',','')
	line=line.replace('\'','')
	return line
line=takeoutseparators(str(zip(* numpy.array([programdata['os'],qw[0]],dtype=float)   )))


import matplotlib
from matplotlib import pyplot

#gen plot
ppo=1000;ppb=1000
forprettypic=True
#i could not just use prgramdata['os'] for the axis!!!!!! WHY???
pltdata=numpy.real(evals(qwargs[0]
,qwargs[1],programdata['bs'][-1],ppb
,programdata['os'][0],programdata['os'][-1],ppo)[0])
largestbase10=int(numpy.log10(numpy.max(pltdata)))
pltdata=pltdata/10**largestbase10
cntrs=pyplot.contourf(numpy.linspace(programdata['os'][0],programdata['os'][-1],ppo)
,numpy.linspace(qwargs[1],programdata['bs'][-1],ppb)
,numpy.swapaxes( pltdata,0,0)
,cmap=matplotlib.cm.gist_heat,antialiased=True
,levels=[round(alongnum,2) for alongnum in numpy.linspace(numpy.min(pltdata),numpy.max(pltdata),20)])
forprettypic=False
pyplot.xlabel('omega (rad/s)');pyplot.xlim([programdata['os'][0],programdata['os'][-1]])
pyplot.ylabel('wavevector beta/omega/c');pyplot.ylim([qwargs[1],programdata['bs'][-1]])
cb=pyplot.colorbar(cntrs)
cb.ax.set_ylabel('s(beta/omega/c,omega)'+' (x10^'+str(largestbase10)+')')
import cStringIO
pltdata=cStringIO.StringIO()
cplt=pyplot.gcf()
cplt.savefig(pltdata, format='png');pltdata.seek(0);
#convert to encoded string
import base64 #i love python
io.put('output.image(s).current',base64.b64encode(pltdata.getvalue()))

io.put('output.string(diag).current'
,'no diagnostic data'
,append=1)

P=scipy.integrate.trapz(qw[0],dx=qw[1])



